<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <meta name="generator" content="pandoc" />
  <title>Using Mercurial</title>
  <style type="text/css">code{white-space: pre;}</style>
</head>
<body>
<style>
body {
    margin: auto;
    padding-right: 1em;
    padding-left: 1em;
    max-width: 44em;
    border-left: 1px solid black;
    border-right: 1px solid black;
    color: black;
    font-family: Verdana, sans-serif;
    font-size: 100%;
    line-height: 140%;
    color: #333;
}
pre, tt{
    font-family: monospace;
    background-color:#f8f8f8;
    padding: 2px 4px;
}
code{
    background-color:#f8f8f8;
    white-space: pre-wrap;
    font-size: 110%;
    padding: 1px 1px;
}
h1 a, h2 a, h3 a, h4 a, h5 a, li a {
    text-decoration: none;
    color: #7a5ada;
}
h1, h2, h3, h4, h5 { font-family: verdana;
                     font-weight: bold;
                     /*border-bottom: 1px dotted black;*/
                     color: #7a5ada; }
h1 {
        font-size: 130%;
}

h2 {
        font-size: 110%;
                     border-bottom: 1px dotted black;
}

h3 {
        font-size: 100%;
                     border-bottom: 1px dotted black;
}

h4 {
        font-size: 90%;
        font-style: italic;
                     border-bottom: 1px dotted black;
}

h5 {
        font-size: 85%;
        font-style: italic;
                     border-bottom: 1px dotted black;
}

h1.title {
        font-size: 200%;
        font-weight: bold;
        padding-top: 0.2em;
        padding-bottom: 0.2em;
        text-align: left;
        border: none;
}

dt code {
        font-weight: bold;
}
dd p {
        margin-top: 0;
}

#footer {
        padding-top: 1em;
        font-size: 70%;
        color: gray;
        text-align: center;
}
</style>
<div id="header">
<h1 class="title">Using Mercurial</h1>
</div>
<p>If you have hg (Mercurial) installed on your system then every time you do something in etm that changes a file --- finish a task, create an action or whatever --- then that change is automatically committed using hg. This means that you can recover any data file(s) as of any change you like. Say the relative path in your data directory of the problem file is &quot;shared/sample_datafile.txt&quot;. Then cd to your data directory and run</p>
<pre><code>$ hg log shared/sample_datafile.txt | less</code></pre>
<p>to see the list of the changes to this file and the times they made. If you think the version you would like to recover is sometime between, say, change number 101 and 106 then you can run</p>
<pre><code>$ hg log shared/sample_datafile.txt -v -p -r 101:106 | less</code></pre>
<p>to see the diffs for the actual changes made by each of these commits. Here is an example of the output</p>
<pre><code>103   ce5d7a1e2486   2013-02-08 13:01 -0500   Daniel Graham
  replaced lines

diff -r f70f45768dd0 -r ce5d7a1e2486 shared/sample_datafile.txt
--- a/shared/sample_datafile.txt        Fri Feb 08 12:53:21 2013 -0500
+++ b/shared/sample_datafile.txt        Fri Feb 08 13:01:36 2013 -0500
@@ -22,9 +22,8 @@
 - join the etm discussion group @c computer @t tasks, sample @g
 http://groups.google.com/group/eventandtaskmanager/topics
 - Overdue skip task @s 2013-01-01 @r w &amp;w TH @o s @d This task is
  due every Thursday but past due instances will be skipped.
-- Overdue restart task @s 2013-02-01 12am @z US/Eastern @d This
 task was due 7 days ago and repeats every 10 days. If finished
 today, it will be due again 10 days from today. @f
 20130208T1253;20130208T0900 @t occasions, sample
-  @r d &amp;i 10 @o r
-- Overdue keep task @s 2013-02-01 12am @z US/Eastern @d This task
 was due 7 days ago and repeats every 10 days. If finished today, it
 will be due again 3 days from today. @f 20130208T1253;20130208T0900
@t occasions, sample
+- Overdue restart task @s -7 @r d &amp;i 10 @o r @d This task was due 7
 days ago and repeats every 10 days. If finished today, it will be
 due again 10 days from today.
+- Overdue keep task @s 2013-02-01 12am @z US/Eastern @d This task
 was due 7 days ago and repeats every 10 days. If finished today, it
 will be due again 3 days from today. @f 20130208T1301;20130201T0000
 @t occasions, sample
   @r d &amp;i 10
 * Monday event @s 1 9a @e 1h @r w &amp;w MO @t events, sample
 * Tuesday event @s 1 10a @e 90m @r w &amp;w TU @t events, sample</code></pre>
<p>This output can also be seen within etm by selecting any item from the file and then, in the details view, pressing Ctrl-H to show the history of changes to the file.</p>
<p>Suppose you would like to restore the file as of 102 (before 103). Then, just to be safe, make a backup of the current file</p>
<pre><code>$ cp shared/sample_datafile.txt shared/sample_datafile.txt.backup</code></pre>
<p>and then restore the file as it existed as of change number 102:</p>
<pre><code>$ hg revert shared/sample_datafile.txt -r 102</code></pre>
<p>Alternatively, You could redirect the exact contents of the file as of change 102 to a temporary file</p>
<pre><code>$ hg cat shared/sample_datafile.txt -r 102 &gt; shared/sample_datafile_102.tmp</code></pre>
<p>then open both the current file and the temporary file in an editor and copy and paste whatever you like from the temporary to the current.</p>
<p>These options are possible, of course, only if you have Mercurial installed on your system and then only for changes made within etm and thus automatically committed. If the problem was created outside of etm, then you can still restore the file as of the last change made within etm before the problem occurred.</p>
</body>
</html>
